package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.TmsshipEntryWharyResult;
import com.steerinfo.framework.mapper.IBaseMapper;
import java.math.*;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

@Mapper
public interface TmsshipEntryWharyResultMapper extends IBaseMapper<TmsshipEntryWharyResult, BigDecimal> {

    // 得到最大id
    BigDecimal selectMaxId();

    @Select("select seq_TMSSHIP_ENTRY.nextval from dual")
    BigDecimal selectEntryId();
}