package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.TmsshipOutWharyResult;
import com.steerinfo.dil.model.TmsshipTotalResult;
import com.steerinfo.framework.mapper.IBaseMapper;
import java.math.*;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

@Mapper
public interface TmsshipOutWharyResultMapper extends IBaseMapper<TmsshipOutWharyResult, BigDecimal> {

    // 查询最大id
    BigDecimal selectMaxId();

    // 插入驶离实绩
    int insert(TmsshipTotalResult tmsshipTotalResult);

    @Select("select seq_TMSSHIP_OUT.nextval from dual")
    BigDecimal selectOutId();
}