package com.steerinfo.dil.service;

import com.steerinfo.dil.model.AmsshipCargoTransferResult;
import com.steerinfo.dil.model.AmsshipDeliveryAttorney;
import com.steerinfo.framework.service.IBaseService;

import java.util.Date;
import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * AmsshipDeliveryAttorney服务接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-18 03:44
 * 类描述
 * 修订历史：
 * 日期：2021-08-18
 * 作者：generator
 * 参考：
 * 描述：AmsshipDeliveryAttorney服务接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
public interface IAmsshipDeliveryAttorneyService{
    List<Map<String,Object>> selectdeliveryAttorney(Map<String,Object> mapVal);

    //新增提货委托
    int insert(Map<String,Object> map);

    //删除提货委托信息
    int deleteByPrimaryKey(BigDecimal attorneyId);

    //修改提货委托信息
    int updateByPrimaryKey(BigDecimal attorneyId);

    //根据主键查找提货委托信息
    AmsshipDeliveryAttorney selectByPrimaryKey(BigDecimal attorneyId);

    //下拉框获取港口名称
    List<Map<String,Object>> getPortName();

    List<Map<String,Object>> getNoticeId();

    //更新
    int updateByPrimaryKeySelective(AmsshipDeliveryAttorney amsshipDeliveryAttorney);

    //通过id渲染数据
    List<Map<String,Object>> getDeliveryAttorneyId(Integer attorneyId);
    /**
     * 查询AttorneyId
     * @return
     */
    List<Map<String, Object>> getAttorneyId();
    /**
     * 查询PortId
     * @return
     */
    List<Map<String, Object>> getPortId();

    /**
     * 查询PierId
     * @return
     */
    List<Map<String, Object>> getPierId();

    /**
     * 仓库id
     * @return
     */
    List<Map<String, Object>> getRmRawId();

    int modifyDeliveryAttroney(Map<String, Object> amsshipDeliveryAttorney);
}