package com.steerinfo.dil.service;

import com.steerinfo.dil.model.OmsshipInstructionsCapacity;
import com.steerinfo.framework.service.IBaseService;
import java.util.Date;
import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * OmsshipInstructionsCapacity服务接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-20 03:06
 * 类描述
 * 修订历史：
 * 日期：2021-08-20
 * 作者：generator
 * 参考：
 * 描述：OmsshipInstructionsCapacity服务接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
public interface IOmsshipInstructionsCapacityService{

    /**
     * 查询orderId
     * @return
     */
    List<Map<String, Object>> getOrderId();

    /**
     * 查询最大id
     * @return
     */
    BigDecimal selectMaxId();

    /**
     * 插入
     * @param omsshipInstructionsCapacity
     * @return
     */
    int insert(Map<String,Object> omsshipInstructionsCapacity);

    /**
     * 根据主键删除
     * @param instructionsCapacityId
     * @return
     */
    int deleteByPrimaryKey(BigDecimal instructionsCapacityId);


    /**
     * 根据主键查看详细
     * @param instructionsCapacityId
     * @return
     */
    OmsshipInstructionsCapacity selectByPrimaryKey(BigDecimal instructionsCapacityId);


    /**
     * 根据主键修改
     * @param omsshipInstructionsCapacity
     * @return
     */
    int updateByPrimaryKeySelective(OmsshipInstructionsCapacity omsshipInstructionsCapacity);


    /**
     * 查询所有船只
     * @return
     */
    List<Map<String,Object>> selectCapacities(Map<String,Object> mapVal);

    /**
     * 得到运力id
     * @return
     */
    List<Map<String,Object>> getCapacityId();

    /**
     * 查询表单信息
     * @param instructionsCapacityId
     * @return
     */
    List<Map<String,Object>> selectInstructionsCapacity(BigDecimal instructionsCapacityId);
}