package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.feign.WmshboundFeign;
import com.steerinfo.dil.mapper.DilBatchMapper;
import com.steerinfo.dil.model.AmsshipCargoTransferResult;
import com.steerinfo.dil.mapper.AmsshipCargoTransferResultMapper;
import com.steerinfo.dil.model.DilBatch;
import com.steerinfo.dil.service.IAmsshipCargoTransferResultService;
import com.steerinfo.dil.util.DataChange;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * AmsshipCargoTransferResult服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-18 03:36
 * 类描述
 * 修订历史：
 * 日期：2021-08-18
 * 作者：generator
 * 参考：
 * 描述：AmsshipCargoTransferResult服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "amsshipCargoTransferResultService")
public class AmsshipCargoTransferResultServiceImpl implements IAmsshipCargoTransferResultService {

    @Autowired
    private AmsshipCargoTransferResultMapper amsshipCargoTransferResultMapper;
    @Autowired
    WmshboundFeign wmshboundFeign;
    @Autowired
    private DilBatchMapper dilBatchMapper;

    @Override
    public List<Map<String, Object>> seletCargoTransfer(Map<String, Object> mapVal) {
        return amsshipCargoTransferResultMapper.seletCargoTransfer(mapVal);
    }

//    @Override
//    @Transactional
//    public int addCargoTransferResult(Map<String,Object> map) {
//        String userId = (String)map.get("userId");
//        String userName=null;
//        if (userId!=null){
//            //根据userId寻找用户名
//             userName = amsshipCargoTransferResultMapper.getUserNameByUserId(userId);
//        }
//        AmsshipCargoTransferResult amsshipCargoTransferResult = new AmsshipCargoTransferResult();
//        //货权转移编号
//        BigDecimal cargoTransferResultId = amsshipCargoTransferResultMapper.selectCargoId();
//        amsshipCargoTransferResult.setCargoTransferResultId(cargoTransferResultId);
//        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
//        String date = sdf.format(new Date());
//        String resultNumber = "ZY" + date + "00" + cargoTransferResultId;
//        amsshipCargoTransferResult.setResultNumber(resultNumber);
//        //获取外轮船名
//        String foreignShipName = (String) map.get("foreignShipName");
//        Integer materialId = (Integer) map.get("materialId");
//        Map<String, Object> selectMap = new HashMap<>();
//        selectMap.put("foreignShipName", foreignShipName);
//        selectMap.put("materialId", new BigDecimal(materialId));
//        List<Map<String,Object>> dilBatchList = dilBatchMapper.selectBatchIdByName(selectMap);
//        DilBatch dilBatch = new DilBatch();
//        // 根据物资id和外轮船名判断批次是否已存在
//        // 存在则只取到批次id
//        if (dilBatchList != null && dilBatchList.size() != 0) {
//            Map<String,Object> dilBatch1 = dilBatchList.get(0);
//            BigDecimal batchId =DataChange.dataToBigDecimal(dilBatch1.get("batchId"));
//            amsshipCargoTransferResult.setBatchId(batchId);
//        }
//        // 若不存在则新增一个新的批次
//        else {
//            //调用新增批次方法
//            BigDecimal batchId1 = dilBatchMapper.selectBatchId();
//            //调用新增批次方法
//            //通过外轮船名和批次查找批次如果没有该批次就执行新增
//            BigDecimal batchIdByMaterialId = amsshipCargoTransferResultMapper.getBatchIdByMaterialId(map);
//            if (batchIdByMaterialId == null) {
//                dilBatch.setBatchId(batchId1);
//                dilBatch.setInsertTime(new Date());
//                dilBatch.setResultForeignShipName(foreignShipName);
//                dilBatch.setMaterialId(new BigDecimal(materialId));
//                dilBatch.setInsertUsername("admin");
//                dilBatchMapper.insertSelective(dilBatch);
//            }
//            //如果批次id为空，获取新增的批次
//            if (batchIdByMaterialId == null) {
//                //获取批次id进行新增
//                amsshipCargoTransferResult.setBatchId(dilBatch.getBatchId());
//            } else {
//                //如果获取的批次不为空设置获取的批次
//                amsshipCargoTransferResult.setBatchId(batchIdByMaterialId);
//            }
//          }
//            //获取货权转移送达单位
//            Integer carrierId = (Integer) map.get("carrierId");
//            amsshipCargoTransferResult.setCarrierId(new BigDecimal(carrierId));
//            //获取联系人
//            String resultContactPerson = (String) map.get("resultContactPerson");
//            amsshipCargoTransferResult.setResultContactPerson(resultContactPerson);
//            //获取联系方式
//            String resultTelephoneFax = (String) map.get("resultTelephoneFax");
//            amsshipCargoTransferResult.setResultTelephoneFax(resultTelephoneFax);
//            //获取货代信息
//            String resultFreightForwardingInfo = (String) map.get("resultFreightForwardingInfo");
//            if (resultFreightForwardingInfo!=null) {
//                amsshipCargoTransferResult.setResultFreightForwardingInfo(resultFreightForwardingInfo);
//            }
//           //获取收货人id
//           Integer groupId = (Integer) map.get("groupId");
//           if (groupId!=null) {
//               amsshipCargoTransferResult.setGroupId(DataChange.dataToBigDecimal(groupId));
//           }
//           //BigDecimal portId = amsshipCargoTransferResultMapper.selectPortId(new BigDecimal(groupId));
//           //获取放货数量
//           String resultNumberOfLoans1 = (String) map.get("resultNumberOfLoans");
//           amsshipCargoTransferResult.setResultNumberOfLoans(new BigDecimal(resultNumberOfLoans1));
//            //获取备注.非必填
//            String resultMemo = (String) map.get("resultMemo");
//            if (resultMemo!=null) {
//                amsshipCargoTransferResult.setResultMemo(resultMemo);
//            }
//            amsshipCargoTransferResult.setResultDateOfLoans(new Date());
//            //设置常规字段
//            amsshipCargoTransferResult.setInsertTime(new Date());
//            amsshipCargoTransferResult.setInsertUsername(userName);
//            amsshipCargoTransferResult.setUpdateTime(new Date());
//            amsshipCargoTransferResult.setInsertUpdateRemark("无");
//            amsshipCargoTransferResult.setDeleted(new BigDecimal(0));
//            return amsshipCargoTransferResultMapper.insertSelective(amsshipCargoTransferResult);
//        }


        @Override
        public int deleteByPrimaryKey (BigDecimal cargoTransferResultId){
            return amsshipCargoTransferResultMapper.deleteByPrimaryKey(cargoTransferResultId);
        }

        @Override
        public int updateByPrimaryKey (BigDecimal cargoTransferResultId){
            return amsshipCargoTransferResultMapper.updateByPrimaryKey(cargoTransferResultId);
        }

        @Override
        public BigDecimal selectMaxId () {
            return amsshipCargoTransferResultMapper.selectMaxId();
        }

        @Override
        public AmsshipCargoTransferResult selectByPrimaryKey (BigDecimal cargoTransferResultId){
            return amsshipCargoTransferResultMapper.selectByPrimaryKey(cargoTransferResultId);
        }

        //展示托运人
        @Override
        public List<Map<String, Object>> getGroup(Map<String,Object> map){
            return amsshipCargoTransferResultMapper.getGroup(map);
        }

        @Override
        public List<Map<String, Object>> getCargoId () {
            return amsshipCargoTransferResultMapper.getCargoId();
        }
        //删除
        @Override
        public int updateByPrimaryKeySelective (AmsshipCargoTransferResult amsshipCargoTransferResult){
            return amsshipCargoTransferResultMapper.updateByPrimaryKeySelective(amsshipCargoTransferResult);
        }

        @Override
        public Map<String,Object> selectByOrder (Integer cargoTransferResultId){
            return amsshipCargoTransferResultMapper.selectByOrder(cargoTransferResultId);
        }

        @Override
        public List<Map<String, Object>> insertBetchId () {
            return amsshipCargoTransferResultMapper.insertBetchId();
        }

        @Override
        public List<Map<String, Object>> selectMaterialId (Map < String, Object > map){
            return amsshipCargoTransferResultMapper.selectMaterialId(map);
        }

        @Override
        public List<Map<String, Object>> selectShipperName (Map < String, Object > map){
            return amsshipCargoTransferResultMapper.selectShipperName(map);
        }

    @Override
    public int update(Map<String, Object> map) {

        List<Map<String, Object>> mapList=null;
        AmsshipCargoTransferResult amsshipCargoTransferResult=new AmsshipCargoTransferResult();
//        if (materialId!=null&&foreignShipName!=null&&!foreignShipName.equals("")) {
//            //通过外轮船名匹配批次
//             mapList = dilBatchMapper.selectBatchIdByName(map);
//        }
//        if (mapList.size()!=0) {
//            Map<String, Object> batchList = mapList.get(0);
//            BigDecimal batchId =DataChange.dataToBigDecimal(batchList.get("batchId"));
//            amsshipCargoTransferResult.setBatchId(batchId);
//        }else {
//            DilBatch batch=new DilBatch();
//            BigDecimal batchId1 = dilBatchMapper.selectBatchId();
//            batch.setBatchId(batchId1);
//            batch.setInsertTime(new Date());
//            batch.setResultForeignShipName(foreignShipName);
//            batch.setMaterialId(materialId);
//            dilBatchMapper.insertSelective(batch);
//            amsshipCargoTransferResult.setBatchId(batchId1);
//        }

        amsshipCargoTransferResult.setCargoTransferResultId(DataChange.dataToBigDecimal(map.get("cargoTransferResultId")));
        amsshipCargoTransferResult.setCarrierId(DataChange.dataToBigDecimal(map.get("carrierId")));
        if (map.get("resultMemo")!=null) {
            amsshipCargoTransferResult.setResultMemo((String) map.get("resultMemo"));
        }
        amsshipCargoTransferResult.setResultContactPerson((String) map.get("resultContactPerson"));
        amsshipCargoTransferResult.setResultNumberOfLoans(DataChange.dataToBigDecimal(map.get("resultNumberOfLoans")));
        amsshipCargoTransferResult.setResultTelephoneFax((String) map.get("resultTelephoneFax"));
        if (map.get("resultFreignForwardingInfo")!=null) {
            amsshipCargoTransferResult.setResultFreightForwardingInfo((String) map.get("resultFreignForwardingInfo"));
        }
        int i = amsshipCargoTransferResultMapper.updateByPrimaryKeySelective(amsshipCargoTransferResult);
        return i;
    }


}
