package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.AmsshipCargoTransferResult;
import com.steerinfo.dil.model.RmsCapacity;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface RmsCapacityMapper extends IBaseMapper<RmsCapacity, BigDecimal> {

    @Select("select seq_RMS_CAPACITY.nextval from dual")
    BigDecimal selectCapacityId();

   //根据运力车牌查看运力id
    Map<String,Object> getCapacityIdByCapacityNumber(String capacityNumber);

}