package com.steerinfo.dil.service;

import com.steerinfo.framework.service.IBaseService;
import com.steerinfo.dil.model.AmsshipCargoTransferResult;
import io.swagger.models.auth.In;
import org.apache.ibatis.annotations.Param;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * AmsshipCargoTransferResult服务接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-18 03:36
 * 类描述
 * 修订历史：
 * 日期：2021-08-18
 * 作者：generator
 * 参考：
 * 描述：AmsshipCargoTransferResult服务接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
public interface IAmsshipCargoTransferResultService{
    List<Map<String,Object>> seletCargoTransfer(Map<String,Object> mapVal);

//    //添加货权转移信息
//    int addCargoTransferResult(Map<String,Object> map);

    //删除货权转移信息
    int deleteByPrimaryKey(BigDecimal cargoTransferResultId);

    //修改货权转移信息
    int updateByPrimaryKey(BigDecimal cargoTransferResultId);

    BigDecimal selectMaxId();

    //  根据关键字查找信息
    AmsshipCargoTransferResult selectByPrimaryKey(BigDecimal cargoTransferResultId);

    //展示托运人
    List<Map<String,Object>> getGroup(Map<String,Object> map);

    List<Map<String,Object>> getCargoId();

    int updateByPrimaryKeySelective(AmsshipCargoTransferResult amsshipCargoTransferResult);

    Map<String,Object> selectByOrder(Integer cargoTransferResultId);

    List<Map<String,Object>>  insertBetchId();

    //查询船运物资id
    List<Map<String,Object>> selectMaterialId(Map<String,Object> map);

    //展示货权转移单位列表
    List<Map<String,Object>> selectShipperName(Map<String,Object> map);

    //更新货权转移
    int update(Map<String, Object> amsshipCargoTransferResult);
}