package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.ShipDynamicsMapper;
import com.steerinfo.dil.service.IShipDynamicsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
public class ShipDynamicsServiceImpl implements IShipDynamicsService {
    @Autowired
    ShipDynamicsMapper shipDynamicsMapper;

    //获取视图里的所有外轮船名，物资名称
    public List<Map<String, Object>> selectAll(Map<String,Object> map) {
        return shipDynamicsMapper.selectAll(map);
    }



    @Override
    public List<Map<String, Object>> selectByshipName(String shipName, String materialName) {
        return shipDynamicsMapper.selectByshipName(shipName,materialName);
    }

}
