package com.steerinfo.dil.util;

import org.springframework.stereotype.Component;

import java.math.BigDecimal;
import java.time.LocalDate;

/**
 * @Description:
 * @Author:HuJianGuo
 * @GreateTime:2021/9/8 15:29
 * @Version:V2.0
 */
@Component
public class NoUtil {

    public String setResultNo(String noStr,BigDecimal resultId) {
        LocalDate now = LocalDate.now();
        String resultNo = noStr +  now.getYear();
        Integer month = now.getMonthValue();
        String monthStr = month.toString();
        Integer day = now.getDayOfMonth();
        String dayStr = day.toString();
        if (monthStr.length() != 2) {
            resultNo = resultNo + "0" + now.getMonthValue();
        }
        else {
            resultNo = resultNo + now.getMonthValue();
        }
        if (dayStr.length() != 2) {
            resultNo = resultNo + "0" + now.getDayOfMonth();
        }
        else {
            resultNo = resultNo + now.getDayOfMonth();
        }
        switch ((resultId.toString()).length()) {
            case 1:
                resultNo = resultNo + "00000000" + resultId;
                break;
            case 2:
                resultNo = resultNo + "0000000" + resultId;
                break;
            case 3:
                resultNo = resultNo + "000000" + resultId;
                break;
            case 4:
                resultNo = resultNo + "00000" + resultId;
                break;
            case 5:
                resultNo = resultNo + "0000" + resultId;
                break;
            case 6:
                resultNo = resultNo + "000" + resultId;
                break;
            case 7:
                resultNo = resultNo + "00" + resultId;
                break;
            case 8:
                resultNo = resultNo + "0" + resultId;
                break;
            default:resultNo = resultNo + resultId;
        }
        return resultNo;
    }
}
